#include "Axis.h"
#include "CoordSystem.h"
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoLineSet.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoDrawStyle.h>

extern M_CoordSystem *CoordS;

M_Axis::M_Axis()
{
 float c = CoordS->get_c();

 /* Initialize .. */
 float axisv[6][3] = { {0.0, 0.0, 0.0}, {c/8, 0.0, 0.0},
                      {0.0, 0.0, 0.0}, {0.0, c/4, 0.0},
                      {0.0, 0.0, 0.0}, {0.0, 0.0, c} };

 float negz_axisv[2][3] = { {0.0, 0.0, 0.0}, {0.0, 0.0, -c/4}};



// long numv[3] = {2, 2, 2}; 
 int32_t  numv[3] = {2, 2, 2};
 int32_t negz = 2;
 /* */
 Axis= new SoSeparator;
// Axis->ref();

 SoMaterial *AxMaterial = new SoMaterial;

 AxCoord = new SoCoordinate3;
 AxL = new SoLineSet;
 nf = new SoFont; 
 Trx= new SoTranslation;
 Try= new SoTranslation;
 Trz= new SoTranslation; 
 x_text=new SoSeparator;
 y_text=new SoSeparator;
 z_text=new SoSeparator;

 /* */

 SoDrawStyle *dstyle= new SoDrawStyle;
 dstyle->lineWidth=2.0;
 Axis->addChild(dstyle);

  AxMaterial->diffuseColor.setValue(.2, .5, .1);
 
  //  AxCoord->point.setValues(0,6,axisv);
  AxCoord->point.setValues(0,2,negz_axisv);
  Axis->addChild(AxCoord);
  

  //  AxL->numVertices.setValues(0,3,numv);    
  AxL->numVertices.setValues(0,1, &negz);
  Axis->addChild(AxL);

  SoSphere *asphere=new SoSphere;
  asphere->radius = 1.2;
  Axis->addChild(asphere);
  /* Add Text */
 
  /* Font .. */

  nf->name.setValue("Times-Roman");
  nf->size.setValue(24.0);
  Axis->addChild(nf);
   
 
  Trx->translation.setValue(c/2+0.1, 0.1, 0.0);
  Try->translation.setValue(0.1, c/2+0.1, 0.0);
  Trz->translation.setValue(0.1, 0.1, c+0.1); 


  x_text->addChild(Trx);
  SoText2 *xT=new SoText2;
  xT->string="X";
  x_text->addChild(xT);
  
 
  y_text->addChild(Try);
  SoText2 *yT=new SoText2;
  yT->string="Y";
  y_text->addChild(yT);
  
 
  z_text->addChild(Trz);
  SoText2 *zT=new SoText2;
  zT->string="Z";
  z_text->addChild(zT);
  
//   Axis->addChild(x_text);
//   Axis->addChild(y_text);
//   Axis->addChild(z_text);
  
}



