/*
 Shape and Attribute nodes
*/
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPointSet.h>
#include <Inventor/nodes/SoLineSet.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoNormal.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/nodes/SoNormalBinding.h>
#include <Inventor/nodes/SoSelection.h>

//#include <Inventor/sensors/SoFieldSensor.h>
#include <Inventor/sensors/SoNodeSensor.h>
#include <Inventor/SoPath.h>
#include <Inventor/nodes/SoDrawStyle.h>
/*
 Translations etc.
*/
#include  <Inventor/nodes/SoTransform.h>

#include <stdlib.h>
#include <math.h>

//#include "callback.h"
#include "ModelInvPts.h"


 Model::Model(){
    // Allocate Space
    TotalRoot =   new SoSeparator; //SoSelection;
    ModelRoot =   new SoSeparator; //SoSelection;
    ModelTransf = new SoTransform;
    Material =    new SoMaterial;

    //New...
    pts_facet  = new SoPointSet;
    lns_set    = new SoLineSet;
    coord3 = new SoCoordinate3;

    SoDrawStyle *_draw=new SoDrawStyle;
    _draw->style=SoDrawStyle::POINTS;
    _draw->pointSize=2.0;

//    normal = new SoNormal;
//    hints  = new SoShapeHints;
//    normalBinding = new SoNormalBinding;

 //   current_poly=0;
 //   current_vertex=0;
    // Initialize
    //Material->diffuseColor.setValue(0.6, 0.1, 0.1);
        Material->diffuseColor.setValue(drand48(), drand48(), drand48());

    //    Material->diffuseColor.setValue(1.0, 0.0, 0.0);
    // Initialize transform
//    SbVec3f FromVector(1.0, 1.0, 1.0);
//    SbVec3f ToVector(sqrt(2.0)/2.0, sqrt(2.0)/2.0, sqrt(2.0)/2.0);
//    ModelTransf->pointAt( FromVector, ToVector );
   // Create Initial Model Structure

//...need to give some hints...

//    hints->faceType = SoShapeHints::UNKNOWN_FACE_TYPE;
//    hints->vertexOrdering = SoShapeHints::CLOCKWISE;

//    normalBinding->value = SoNormalBinding::PER_FACE;

//    ModelRoot->addChild(hints);
//    ModelRoot->addChild(normalBinding);
//    ModelRoot->addChild(normal);

    ModelRoot->addChild(_draw);
    ModelRoot->addChild(coord3);
//    ModelRoot->addChild(facet);

    ModelRoot->addChild(pts_facet);

//	ModelRoot->addChild(lns_set);
    TotalRoot->addChild(Material);
    TotalRoot->addChild(ModelTransf);
    TotalRoot->addChild(ModelRoot);

    _total_num_points=0;


    // attach two sensors to the transform
//    TransSens = new SoNodeSensor;
/*(translationChangedCB,
						 this->ModelTransf);*/

/*
    RotSens   = new SoFieldSensor(rotationChangedCB,
						 this->ModelTransf);
*/
/*    TransSens->setPriority(0);
    TransSens->setFunction(translationChangedCB);
    TransSens->setData(this);
    TransSens->attach( ModelTransf );
  */

 //   RotSens->attach( &(ModelTransf->rotation) );



 //     TotalRoot->policy = SoSelection::SINGLE;
 //     TotalRoot->setPickFilterCallback(PickSelectionCallback, TotalRoot);
 //     TotalRoot->addSelectionCallback(SelectionCallback, TotalRoot);
 //     TotalRoot->addDeselectionCallback(DeSelectionCallback, NULL);
}

void
Model::addOnePoint(float onePoint[3])
{
    coord3->point.set1Value(_total_num_points, onePoint);
    _total_num_points++;
}

void
Model::StartOfModel()
{
    _total_num_points=0;
}

void
Model::EndOfModel()
{
    pts_facet->numPoints=_total_num_points;
}

void
Model::RandomColor()
{
    static int num_time=0;

    double c1=drand48();
    double c2=drand48();
    double c3=drand48();
    Material->diffuseColor.setValue(c1, c2, c3); //change the color
//    printf("change color to %lf %lf %lf\n", c1, c2, c3);
//    if (num_time==0) Material->diffuseColor.setValue(0.6, 0.1, 0.7);
//    else Material->diffuseColor.setValue(1.0, 0.0, 0.0);
//    num_time++;
}

void
Model::setColor(double r, double g, double b)
{
    Material->diffuseColor.setValue(r, g, b);
}

void
Model::addPoints(float pts[][3], int NumPts)

{

    coord3->point.setValues(0, NumPts, pts);
    pts_facet->numPoints=NumPts;
    lns_set->numVertices=NumPts;

  // Initialize nodes
/* ---- Out ----
  SoSeparator   *sep   = new SoSeparator;
  SoMaterial    *mat   =new SoMaterial;
  SoCoordinate3 *coord3=new SoCoordinate3;
  SoFaceSet     *faceset=new SoFaceSet;

  SoNormal      *my_norm   = new SoNormal;
  SoShapeHints  *hints     = new SoShapeHints;
 -----*/
 // normal
//--Out   normal->vector.setValue(normal[0], normal[1], normal[2]);
  // Fill nodes
//--Out   hints->faceType = SoShapeHints::UNKNOWN_FACE_TYPE;
//  hints->shapeType = SoShapeHints::SOLID;
/* --Out
 if (divPoly)
      hints->vertexOrdering =  SoShapeHints::COUNTERCLOCKWISE;
  else
      hints->vertexOrdering = SoShapeHints::CLOCKWISE;
 --Out */

/*--Out
  mat->diffuseColor.setValue(color[0], color[1], color[2]);

  coord3->point.setValues(0, NumVertices, Vertices);
  faceset->numVertices = NumVertices;
*/
 // Add them to the model

/* --Out
 sep->addChild(hints);
 sep->addChild(my_norm);
 sep->addChild(mat);
 sep->addChild(coord3);
 sep->addChild(faceset);

 ModelRoot->addChild(sep);
*/
 // Give name to node sep == the ptr to face structure
/* --Out
 SbName FaceName( PtrStr );
 sep->setName( FaceName );
*/

 // This is a new extension....
 // Include a SoLineSet node also if needed...

/* --Out
  SoSeparator *lineSep= new SoSeparator;
  SoLineSet   *lineSet= new SoLineSet;
  lineSep->addChild( mat );
  lineSep->addChild( coord3 );
  lineSep->addChild( lineSet );
*/
  // ignore while rendering
  // does not work...
  //  lineSep->setOverride( FALSE );
  // ModelRoot->addChild( lineSep );


}





void
Model::rotationChangedCB( void *data, SoSensor * ){

    SoTransform *transf=( SoTransform * )data;
    printf("Rotation changed>>>>>>>>>> \n");


}

/*
void
Model::addaVector( float From[], float Direction[] ){

  float vecCoords[2][3];
  int i;

  SoSeparator   *norSep   = new SoSeparator;
  SoCoordinate3 *norCoord = new SoCoordinate3;
  SoMaterial    *norMat      = new SoMaterial;
  SoLineSet     *norLine   = new SoLineSet;

  for (i=0; i<3; ++i) {
    vecCoords[0][i]=From[i];
    vecCoords[1][i]=From[i] + Direction[i];
  }

  norMat->diffuseColor.setValue( 1.0, 0.8, 0.0 ); //yellow

  norCoord->point.setValues(0, 2, vecCoords);

  norSep->addChild( norMat );
  norSep->addChild( norCoord );
  norSep->addChild( norLine );

  TotalRoot->addChild( norSep );

}


*/
